// Copyright 2023 Sirbu Dan
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <interrupt.hpp>

static void (*callback)(void*);
static void* callbackArg;

ISR(INT0_vect)
{
  callback(callbackArg);
}

void setupInterrupts()
{
    callback = NULL;
    callbackArg = NULL;

    cli();
    EICRA &= ~(1 << ISC00);
    EIMSK |= (1 << INT0);
    sei();
}

void setButtonCallback(void (*func)(void*), void* arg)
{
    callback = func;
    callbackArg = arg;
}