// Copyright 2023 Sirbu Dan
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <serial.hpp>

inline void send(char data)
{
    while (!(UCSR0A & (1 << UDRE0)))
    ;

    UDR0 = data;
}

void serialBegin()
{
  UBRR0 = 103;

  UCSR0B = (1 << TXEN0) | (1 << RXEN0);

  UCSR0C &= ~(1 << USBS0);
  UCSR0C |= (3 << UCSZ00);
}

void print(const char* message)
{
    while (*message != '\0') {
        send(*message++);
    }
}